import logging
import unittest
from logging import DEBUG
from unittest import TestCase

from vanwanet_scrape.scraper import Scraper


class TestScraper(TestCase):

    def test_challenge(self):
        log = logging.getLogger("default")
        log.setLevel(DEBUG)
        scraper = Scraper(
            headers={
                "User-Agent": "Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:86.0) Gecko/20100101 Firefox/86.0",
                "Accept": "text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8",
                "Referer": "https://8kun.top/index.html"
            },
            domains=[
                "8kun.top",
                "media.8kun.top",
                "sys.8kun.net"
            ],
            logger=log
        )

        r = scraper.get("https://sys.8kun.top/board-search.php?page=0")

        self.assertTrue(r.status_code == 200)
        self.assertTrue("VanwaNet DDoS Mitigation" not in r.text)


if __name__ == '__main__':
    unittest.main()
